Sub SetGlobal()
' Created 11/11/98 by Ora Matushansky, MIT
' This macro comes AS IS with no warranty.
' It is a shareware. All comments welcome.
'
' Sets global variables for the document
 ScreenUpdating = False
 SetDocumentNumber
 SetExampleNumber
 SetBookMarkIdentifier

End Sub
Sub InsertExample()
'
' Macro created 11/11/98 by Ora Matushansky, MIT
' This macro comes AS IS with no warranty.
' It is a shareware. All comments welcome.

    Dim BookmarkNumber As Integer
'Change the style to example
    Selection.Style = ActiveDocument.Styles("example")

Insert:
'This block increases the Example Number variable
    With ActiveDocument.Variables("ExampleNumber")
        On Error GoTo ErrorHandler
        .Value = .Value + 1
        BookmarkNumber = .Value
    End With
   
'This block inserts a dummy text to create a bookmark around
    Selection.TypeText Text:="(OM)"
    'Move to the left of the right bracket:
    Selection.MoveLeft Unit:=wdCharacter, Count:=1
    'Select the contents of the bracket (OM):
    Selection.MoveLeft Unit:=wdCharacter, Count:=2, Extend:=wdExtend
    'This block creates a new BookMark
    With ActiveDocument.Bookmarks
        .Add Range:=Selection.Range, Name:=ActiveDocument.Variables("BookmarkIdentifier").Value & "_" & ActiveDocument.Variables("DocumentNumber").Value & Chr(79) & Chr(77) & Format(BookmarkNumber)
        .DefaultSorting = wdSortByName
        .ShowHidden = False
    End With

    'Move inside the bookmark
    Selection.MoveLeft Unit:=wdCharacter, Count:=1
    'Delete the symbol to the left
    Selection.Delete Unit:=wdCharacter, Count:=1
    'Insert an example number by FIELD method
    Selection.Fields.Add Range:=Selection.Range, Type:=wdFieldEmpty, Text:= _
        "SEQ ex", PreserveFormatting:=True
    'Delete the symbol to the right
    Selection.Delete Unit:=wdCharacter, Count:=1
'Move to the right of the right bracket:
Selection.MoveRight Unit:=wdCharacter, Count:=1

ExitLabel:
    Exit Sub
ErrorHandler:
    MsgBox "Global bookmark variables not defined."
    'Initialize the document's variables
    Call SetGlobal
    'Return to the beginning of the procedure and try again
    GoTo Insert
End Sub

Private Function AskForIdentifier() As String
' Created 11/11/98 by Ora Matushansky, MIT
' This macro comes AS IS with no warranty.
' It is a shareware. All comments welcome.

'Users of this macro set should be aware that every
'example will be accompanied by a bookmark. However
'this will render it difficult to refer to specific
'bookmarks in long texts. An extra macro will allow
'you to define personal bookmarks.
'I advise you to use for your bookmarks a word that
'begins with a Z. This will let you find easily all
'the personal bookmarks

Dim Message, Title, Default, MyValue
Message = "Please type in an identifier for your bookmarks." & Chr(13) & "Use letters, digits or underscore." ' Set prompt."
Title = "Type in a word"   ' Set title.
Default = "ZZ_end"         ' Set default.
' Display message, title, and default value.
'change this - if cancel (ie ""), cancel rather than ZZ

Dummy = InputBox(Message, Title, Default)
If Dummy = "" Then AskForIdentifier = Default Else AskForIdentifier = Dummy
End Function

Private Sub SetDocumentNumber()
' Created 11/11/98 by Ora Matushansky, MIT
' This macro comes AS IS with no warranty.
' It is a shareware. All comments welcome.

' This procedure sets a unique number variable for
' each document based on this template

' If the DocumentNumber variable exists, set it to 0
    
    num = 0 ' set the indicator to zero
    
    'Check if the varaible is set for the document
    For Each aVar In ActiveDocument.Variables
    If aVar.Name = "DocumentNumber" Then num = aVar.index
    Next aVar
    
    If num = 0 Then 'If DocumentNumber variable doesn't exist, create it
        ActiveDocument.Variables.Add Name:="DocumentNumber", Value:=0
    Else            'If DocumentNumber variable exists, update the template variable
        ScreenUpdating = False
        With ActiveDocument.AttachedTemplate.OpenAsDocument
        'If there have been more than 1000 documents, it's unlikely that the names would coincide
            If .Variables("DocumentNumber") > 1000 Then
                .Variables("DocumentNumber") = 1
            Else
                .Variables("DocumentNumber") = .Variables("DocumentNumber") + 1
            End If
            .Close SaveChanges:=wdSaveChanges
        End With
    End If
    
End Sub

Private Sub SetExampleNumber()
' Created 11/11/98 by Ora Matushansky, MIT
' This macro comes AS IS with no warranty.
' It is a shareware. All comments welcome.

' This section sets up the counter for the
' example bookmarks

'If the ExampleNumber variable exists, set it to 0
    num = 0 ' set the indicator to zero
    For Each aVar In ActiveDocument.Variables
        If aVar.Name = "ExampleNumber" Then num = aVar.index
    Next aVar
    
'If ExampleNumber variable doesn't exist, create it
    If num = 0 Then
        ActiveDocument.Variables.Add Name:="ExampleNumber", Value:=0
    End If

'This line runs for a new document and sets the Example Number to zero
    ActiveDocument.Variables("ExampleNumber").Value = 0
End Sub

 Sub SetBookMarkIdentifier()
' Created 11/11/98 by Ora Matushansky, MIT
' This macro comes AS IS with no warranty.
' It is a shareware. All comments welcome.

' This section sets the unique bookmark identifier for each document

' If the BookmarkIdentifier variable exists, set it to zero
' DocumentNumber variable will exist if this Macro is added to a template
    num = 0 ' set the indicator to zero
    For Each aVar In ActiveDocument.Variables
    If aVar.Name = "BookmarkIdentifier" Then num = aVar.index
    Next aVar
    
    If num = 0 Then 'If BookmarkIdentifier variable doesn't exist, create it
        ActiveDocument.Variables.Add Name:="BookmarkIdentifier", Value:=AskForIdentifier
    Else            'If DocumentNumber variable exists, increase it
        ActiveDocument.Variables(num).Value = AskForIdentifier
    End If
    
    Controller = 0
    While TestIdentifier = False And Controller < 10
        ActiveDocument.Variables("BookmarkIdentifier").Value = AskForIdentifier
        Controller = Controller + 1
    Wend
    If Controller = 10 Then ActiveDocument.Variables("BookmarkIdentifier").Value = "YourName"

End Sub

Private Function TestIdentifier() As Boolean
' Created 11/11/98 by Ora Matushansky, MIT
' This macro comes AS IS with no warranty.
' It is a shareware. All comments welcome.

' Test the validity of the Identifier
    Selection.TypeText Text:=Chr(79) & Chr(77)
    Selection.MoveLeft Unit:=wdCharacter, Count:=2, Extend:=wdExtend
    With ActiveDocument.Bookmarks
        On Error GoTo ErrorHandler
        .Add Range:=Selection.Range, Name:=ActiveDocument.Variables("BookmarkIdentifier").Value
        .DefaultSorting = wdSortByName
        .ShowHidden = False
    End With
    Selection.Delete Unit:=wdCharacter, Count:=1
    TestIdentifier = True
    Exit Function
ErrorHandler:
    TestIdentifier = False
    MsgBox "Bad name for a bookmark. Please use letters only."

End Function

Sub SpecialBookMark()
' This is a macro to insert examples with outstanding bookmarks
' Created 11/11/98 by Ora Matushansky, MIT
' This macro comes AS IS with no warranty.
' It is a shareware. All comments welcome.
' This procedure will insert a bookmark with an individual label

Dim TemporaryBookMark As String

TemporaryBookMark = ActiveDocument.Variables("BookmarkIdentifier").Value
ActiveDocument.Variables("BookmarkIdentifier").Value = AskForIdentifier
InsertExample
ActiveDocument.Variables("BookmarkIdentifier").Value = TemporaryBookMark
End Sub
